SystemOrganization addCategory: #ConfigurationOfOSUnix!

Object subclass: #ConfigurationOfOSUnix
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfOSUnix'!

!ConfigurationOfOSUnix commentStamp: 'TorstenBergmann 1/9/2015 00:43' prior: 0!
Configuration for OS-Unix!

!ConfigurationOfOSUnix class methodsFor: 'development support' stamp: 'TorstenBergmann 1/9/2015 00:40'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfOSUnix class methodsFor: 'private' stamp: 'TorstenBergmann 1/9/2015 00:40'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfOSUnix class methodsFor: 'catalog' stamp: 'TorstenBergmann 10/22/2015 15:50'!
catalogChangeLog
	"Returns a paragraph describing the most important changes in the configuration class."
	^ '- 0.3 - 22.10.2015 - Unify to uppercase UNIX classes
[[[
	ConfigurationOfDesktopManager project version: ''0.3'' ) load				
]]]
'! !

!ConfigurationOfOSUnix class methodsFor: 'catalog' stamp: 'TorstenBergmann 2/8/2016 21:53'!
catalogContactInfo
	"Returns a paragraph describing contact information such as email, mailing lists and website."
	^'Contact the author or ask on the pharo-user mailinglist'! !

!ConfigurationOfOSUnix class methodsFor: 'catalog' stamp: 'TorstenBergmann 10/22/2015 15:52'!
catalogDescription
	"Returns a paragraph describing the project"
	^ 'A part of the OS-XXX series to easier work with native operating system platforms. Here for using Unix environments in Pharo.'! !

!ConfigurationOfOSUnix class methodsFor: 'catalog' stamp: 'TorstenBergmann 10/22/2015 15:52'!
catalogKeyClassesAndExample
	"Returns a paragraph or more describing the key classes of your project. You can use Pillar/Pier syntax to layout out the text i.e., ==Code== and - for bullet."
	^ ' '! !

!ConfigurationOfOSUnix class methodsFor: 'catalog' stamp: 'TorstenBergmann 10/22/2015 15:52'!
catalogKeywords
	"Returns an array of symbols"
	^ #(os unix native) ! !

!ConfigurationOfOSUnix class methodsFor: 'private' stamp: 'TorstenBergmann 1/9/2015 00:40'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfOSUnix class methodsFor: 'private' stamp: 'TorstenBergmann 1/9/2015 00:40'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfOSUnix class methodsFor: 'metacello tool support' stamp: 'TorstenBergmann 1/9/2015 00:40'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfOSUnix class methodsFor: 'loading' stamp: 'TorstenBergmann 1/9/2015 00:40'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfOSUnix class methodsFor: 'loading' stamp: 'TorstenBergmann 1/9/2015 00:40'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfOSUnix class methodsFor: 'loading' stamp: 'TorstenBergmann 1/9/2015 00:40'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfOSUnix class methodsFor: 'accessing' stamp: 'TorstenBergmann 1/9/2015 00:40'!
project

	^self new project! !

!ConfigurationOfOSUnix class methodsFor: 'development support' stamp: 'TorstenBergmann 1/9/2015 00:40'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfOSUnix methodsFor: 'baselines' stamp: 'TorstenBergmann 1/9/2015 00:42'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/OS/OS-Unix/main/'.
		spec 
			package: #'OS-Unix-Core';
			package: #'OS-Unix-Tests-Core' with: [
				spec requires: #(#'OS-Unix-Core' ). ].
		spec 
			group: 'Core' with: #(#'OS-Unix-Core' );
			group: 'Tests' with: #(#'OS-Unix-Tests-Core' );
			group: 'default' with: #('Core' 'Tests' ). ].
! !

!ConfigurationOfOSUnix methodsFor: 'baselines' stamp: 'TorstenBergmann 1/9/2015 01:36'!
baseline02: spec
	<version: '0.2-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/OS/OS-Unix/main/'.
		spec 
			package: #'OS-Unix-Core';
			package: #'OS-Unix-Environment' with: [
				spec requires: #(#'OS-Unix-Core' ). ];
			package: #'OS-Unix-Tests-Core' with: [
				spec requires: #(#'OS-Unix-Core' ). ];
			package: #'OS-Unix-Tests-Environment' with: [
				spec requires: #(#'OS-Unix-Environment' #'OS-Unix-Tests-Core' ). ].
		spec 
			group: 'Core' with: #(#'OS-Unix-Core' #'OS-Unix-Environment' );
			group: 'Tests' with: #(#'OS-Unix-Tests-Core' #'OS-Unix-Tests-Environment' );
			group: 'default' with: #('Core' 'Tests' ). ].
! !

!ConfigurationOfOSUnix methodsFor: 'baselines' stamp: 'TorstenBergmann 1/9/2015 01:37'!
baseline03: spec
	<version: '0.3-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/OS/OS-Unix/main/'.
		spec 
			package: #'OS-Unix-Core';
			package: #'OS-Unix-Environment' with: [
				spec requires: #(#'OS-Unix-Core' ). ];
			package: #'OS-Unix-Tests-Core' with: [
				spec requires: #(#'OS-Unix-Core' ). ];
			package: #'OS-Unix-Tests-Environment' with: [
				spec requires: #(#'OS-Unix-Environment' #'OS-Unix-Tests-Core' ). ].
		spec 
			group: 'Core' with: #(#'OS-Unix-Core' #'OS-Unix-Environment' );
			group: 'Tests' with: #(#'OS-Unix-Tests-Core' #'OS-Unix-Tests-Environment' );
			group: 'default' with: #('Core' 'Tests' ). ].
! !

!ConfigurationOfOSUnix methodsFor: 'baselines' stamp: 'TorstenBergmann 10/22/2015 15:42'!
baseline04: spec
	<version: '0.4-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/OS/OS-Unix/main/'.
		spec 
			package: #'OS-Unix-Core';
			package: #'OS-Unix-Environment' with: [
				spec requires: #(#'OS-Unix-Core' ). ];
			package: #'OS-Unix-Tests-Core' with: [
				spec requires: #(#'OS-Unix-Core' ). ];
			package: #'OS-Unix-Tests-Environment' with: [
				spec requires: #(#'OS-Unix-Environment' #'OS-Unix-Tests-Core' ). ].
		spec 
			group: 'Core' with: #(#'OS-Unix-Core' #'OS-Unix-Environment' );
			group: 'Tests' with: #(#'OS-Unix-Tests-Core' #'OS-Unix-Tests-Environment' );
			group: 'default' with: #('Core' 'Tests' ). ].
! !

!ConfigurationOfOSUnix methodsFor: 'baselines' stamp: 'TorstenBergmann 2/8/2016 21:20'!
baseline05: spec
	<version: '0.5-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/OS/OS-Unix/main/'.
		spec 
			package: #'OS-Unix-Core';
			package: #'OS-Unix-Environment' with: [
				spec requires: #(#'OS-Unix-Core' ). ];
			package: #'OS-Unix-Tests-Core' with: [
				spec requires: #(#'OS-Unix-Core' ). ];
			package: #'OS-Unix-Tests-Environment' with: [
				spec requires: #(#'OS-Unix-Environment' #'OS-Unix-Tests-Core' ). ].
		spec 
			group: 'Core' with: #(#'OS-Unix-Core' #'OS-Unix-Environment' );
			group: 'Tests' with: #(#'OS-Unix-Tests-Core' #'OS-Unix-Tests-Environment' );
			group: 'default' with: #('Core' 'Tests' ). ].
! !

!ConfigurationOfOSUnix methodsFor: 'accessing' stamp: 'TorstenBergmann 1/9/2015 00:40'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfOSUnix methodsFor: 'symbolic versions' stamp: 'TorstenBergmann 2/8/2016 21:20'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.5-baseline'.
! !

!ConfigurationOfOSUnix methodsFor: 'accessing' stamp: 'TorstenBergmann 1/9/2015 00:40'!
project

	^ project ifNil: [ 
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfOSUnix methodsFor: 'symbolic versions' stamp: 'TorstenBergmann 2/8/2016 21:20'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '0.4'.
! !

!ConfigurationOfOSUnix methodsFor: 'versions' stamp: 'TorstenBergmann 1/9/2015 01:32'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 0.1'.
		spec author: 'TorstenBergmann'.
		spec timestamp: '1/9/2015 00:42'.
		spec 
			package: #'OS-Unix-Core' with: 'OS-Unix-Core-TorstenBergmann.1';
			package: #'OS-Unix-Tests-Core' with: 'OS-Unix-Tests-Core-TorstenBergmann.1'. ].
! !

!ConfigurationOfOSUnix methodsFor: 'versions' stamp: 'TorstenBergmann 3/19/2015 13:39'!
version02: spec
	<version: '0.2' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 0.2'.
		spec author: 'TorstenBergmann'.
		spec timestamp: '1/9/2015 01:35'.
		spec 
			package: #'OS-Unix-Core' with: 'OS-Unix-Core-TorstenBergmann.5';
			package: #'OS-Unix-Environment' with: 'OS-Unix-Environment-TorstenBergmann.2';
			package: #'OS-Unix-Tests-Core' with: 'OS-Unix-Tests-Core-TorstenBergmann.3';
			package: #'OS-Unix-Tests-Environment' with: 'OS-Unix-Tests-Environment-TorstenBergmann.1'. ].
! !

!ConfigurationOfOSUnix methodsFor: 'versions' stamp: 'TorstenBergmann 10/22/2015 15:45'!
version03: spec
	<version: '0.3' imports: #('0.3-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 0.3'.
		spec author: 'TorstenBergmann'.
		spec timestamp: '10/22/2015 01:35'.
		spec 
			package: #'OS-Unix-Core' with: 'OS-Unix-Core-TorstenBergmann.6';
			package: #'OS-Unix-Environment' with: 'OS-Unix-Environment-TorstenBergmann.3';
			package: #'OS-Unix-Tests-Core' with: 'OS-Unix-Tests-Core-TorstenBergmann.4';
			package: #'OS-Unix-Tests-Environment' with: 'OS-Unix-Tests-Environment-TorstenBergmann.2'. ].
! !

!ConfigurationOfOSUnix methodsFor: 'versions' stamp: 'TorstenBergmann 2/8/2016 22:20'!
version04: spec
	<version: '0.4' imports: #('0.4-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 0.4'.
		spec author: 'TorstenBergmann'.
		spec timestamp: '02/08/2016 01:35'.
		spec 
			package: #'OS-Unix-Core' with: 'OS-Unix-Core-TorstenBergmann.10';
			package: #'OS-Unix-Environment' with: 'OS-Unix-Environment-TorstenBergmann.4';
			package: #'OS-Unix-Tests-Core' with: 'OS-Unix-Tests-Core-TorstenBergmann.4';
			package: #'OS-Unix-Tests-Environment' with: 'OS-Unix-Tests-Environment-TorstenBergmann.2'. ].
! !
